package net.locusworks.s3sync.database;

import javax.sql.DataSource;

import org.springframework.boot.jdbc.DataSourceBuilder;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Primary;
import org.springframework.stereotype.Component;
import net.locusworks.logger.ApplicationLogger;
import net.locusworks.logger.ApplicationLoggerFactory;

@Primary
@Component
public class S3SyncDataSource {
  
  private static final String DRIVER = "org.h2.Driver";
  private static final String JNDI_STRING = "jdbc:h2:file:./s3sync;MODE=MYSQL;DATABASE_TO_UPPER=false";

  /**
   * Create the data source bean
   * @return the data source bean
   * @throws Exception 
   */
  @Bean
  public DataSource dataSource() throws Exception {
    return getDataSource();
  }


  private DataSource getDataSource() throws Exception {
    ApplicationLogger logger = ApplicationLoggerFactory.getLogger(this.getClass());

    String url = JNDI_STRING;

    logger.debug(String.format("Database connection string: %s", url));

    return DataSourceBuilder
        .create()
        .username("sa")
        .password("")
        .url(url)
        .driverClassName(DRIVER)
        .build();
  }

}
