package net.locusworks.s3sync.database.entities;

import java.io.Serializable;
import java.util.Date;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

@Entity
@Table(name ="file_info", catalog="S3SYNC", schema="s3sync")
@NamedQueries({
  @NamedQuery(name = "FileInfo.findAll", query="SELECT f FROM FileInfo f")
})
public class FileInfo implements Serializable {
  private static final long serialVersionUID = 1L;
  @Id
  @GeneratedValue(strategy = GenerationType.IDENTITY)
  @Basic(optional = false)
  @Column(name = "ID")
  private Long id;
  
  @Basic(optional = false)
  @Column(name = "FILE_NAME")
  private String fileName;
  
  @Basic(optional = false)
  @Column(name = "FILE_HASH")
  private String fileHash;
  
  @Basic(optional = false)
  @Column(name = "FILE_PATH")
  private String filePath;
  
  @Basic(optional = true)
  @Column(name = "UPLOAD_DATE")
  @Temporal(TemporalType.TIMESTAMP)
  private Date uploadDate;
  
  @Basic(optional = false)
  @Column(name = "UPLOADED")
  private Boolean uploaded;

  public FileInfo() {
  }

  public FileInfo(Long id) {
    this.id = id;
  }

  /**
   * @param id
   * @param fileName
   * @param fileHash
   * @param fileType
   * @param uploadDate
   * @param uploaded
   */
  public FileInfo(Long id, String fileName, String fileHash, String filePath, Date uploadDate, Boolean uploaded) {
    this.id = id;
    this.fileName = fileName;
    this.fileHash = fileHash;
    this.filePath = filePath;
    this.uploadDate = uploadDate;
    this.uploaded = uploaded;
  }

  /**
   * @return the id
   */
  public synchronized final Long getId() {
    return id;
  }

  /**
   * @param id the id to set
   */
  public synchronized final void setId(Long id) {
    this.id = id;
  }

  /**
   * @return the fileName
   */
  public synchronized final String getFileName() {
    return fileName;
  }

  /**
   * @param fileName the fileName to set
   */
  public synchronized final void setFileName(String fileName) {
    this.fileName = fileName;
  }

  /**
   * @return the fileHash
   */
  public synchronized final String getFileHash() {
    return fileHash;
  }

  /**
   * @param fileHash the fileHash to set
   */
  public synchronized final void setFileHash(String fileHash) {
    this.fileHash = fileHash;
  }

  /**
   * @return the fileType
   */
  public synchronized final String getFilePath() {
    return filePath;
  }

  /**
   * @param fileType the fileType to set
   */
  public synchronized final void setFilePath(String filePath) {
    this.filePath = filePath;
  }

  /**
   * @return the uploadDate
   */
  public synchronized final Date getUploadDate() {
    return uploadDate;
  }

  /**
   * @param uploadDate the uploadDate to set
   */
  public synchronized final void setUploadDate(Date uploadDate) {
    this.uploadDate = uploadDate;
  }

  /**
   * @return the uploaded
   */
  public synchronized final Boolean getUploaded() {
    return uploaded;
  }

  /**
   * @param uploaded the uploaded to set
   */
  public synchronized final void setUploaded(Boolean uploaded) {
    this.uploaded = uploaded;
  }

  @Override
  public int hashCode() {
    int hash = 0;
    hash += (id != null ? id.hashCode() : 0);
    return hash;
  }

  @Override
  public boolean equals(Object object) {
    // TODO: Warning - this method won't work in the case the id fields are not set
    if (!(object instanceof FileInfo)) {
      return false;
    }
    FileInfo other = (FileInfo) object;
    if ((this.id == null && other.id != null) || (this.id != null && !this.id.equals(other.id))) {
      return false;
    }
    return true;
  }

  @Override
  public String toString() {
    return "net.locusworks.battletech.s3sync.entities.FileInfo[ id=" + id + " ]";
  }
}
