package net.locusworks.s3sync.database.repos;

import javax.transaction.Transactional;

import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;

import net.locusworks.s3sync.database.entities.FileInfo;

/**
 *
 * @author isaac
 */
public interface FileInfoRepository extends CrudRepository<FileInfo, Long> {
    
  FileInfo findByFileHash(String fileHash);
  
  boolean existsByFileHash(String fileHash);
  
  @Modifying
  @Transactional
  @Query("DELETE FROM FileInfo fh WHERE fh.fileHash = ?1")
  void deleteByFileHash(String fileHash);
  
}
