package net.locusworks.s3sync.scp;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import com.jcraft.jsch.JSchException;
import net.locusworks.logger.ApplicationLoggerFactory;
import net.locusworks.logger.LogLevel;

public class LocalFileMessage extends AbstractSshMessage {

  private Path syncFolder;
  
  public LocalFileMessage(Path localFolder) {
    super(true, false, null, ApplicationLoggerFactory.getLogger(LocalFileMessage.class));
    this.syncFolder = localFolder;
  }
  
  @Override
  public void execute() throws IOException, JSchException {
    Files.walk(syncFolder)
    .filter(f -> Files.isRegularFile(f))
    .forEach(f -> {
      log("Found File: " + f, LogLevel.DEBUG);
      if (fileCallback != null) fileCallback.accept(syncFolder.resolve(f));
    });
  }

}
